> module Angabe4 where
> import Data.List

1. Vervollstaendigen Sie gemaess Angabentext!
2. Vervollst�ndigen Sie auch die vorgegebenen Kommentaranf�nge!
3. Loeschen Sie keine Deklarationen aus diesem Rahmenprogramm, auch nicht die Modulanweisug!
4. Achten Sie darauf, dass `Gruppe' Leserechte fuer Ihre Abgabedatei hat!


Datenstrukturen fuer eine einfache Buchhaltung:

> type Nat1    = Int
> type Name    = String
> newtype Cent = C { cents :: Nat1
>                  } deriving (Eq,Ord,Show)
> type Brutto  = Cent
> type Netto   = Cent
> data Skonto  = KeinSkonto | DreiProzent
>                | FuenfProzent | ZehnProzent deriving (Eq,Ord,Show)
> data Tag     = I | II | III | IV | V | VI | VII | VIII | IX | X
>                | XI | XII | XIII | XIV | XV | XVI | XVII | XVIII
>                | XIX | XX | XXI | XXII | XXIII | XXIV | XXV
>                | XXVI | XXVII | XXVIII | XXIX | XXX
>                | XXXI deriving (Eq,Ord,Show)
> data Monat   = Jan | Feb | Mar | Apr | Mai | Jun | Jul | Aug
>                | Sep | Okt | Nov | Dez deriving (Eq,Ord,Show)
> type Jahr    = Nat1
> data Datum   = D { tag   :: Tag,
>                    monat :: Monat,
>                    jahr  :: Jahr
>                  } deriving (Eq,Show,Ord)

> data Geschaeftspartner = GP { partner :: Name,
>                               seit :: Datum
>                              } deriving (Eq,Show,Ord)
> data Geschaeftsvorfall = Zahlung { brutto :: Brutto,
>                                    skonto :: Skonto,
>                                    zahlung_vom :: Datum
>                                  }
>                          | Gutschrift { gutschriftsbetrag :: Cent,
>                                         gutschrift_vom :: Datum
>                                       }
>                          deriving (Eq,Show)
> type Kassabucheintrag = (Geschaeftspartner,Geschaeftsvorfall)
> newtype Kassabuch = KB [Kassabucheintrag] deriving (Eq,Show)

Helper functions:

> day_to_int :: Tag -> Int
> day_to_int I = 1
> day_to_int II = 2
> day_to_int III = 3
> day_to_int IV = 4
> day_to_int V = 5
> day_to_int VI = 6
> day_to_int VII = 7
> day_to_int VIII = 8
> day_to_int IX = 9
> day_to_int X = 10
> day_to_int XI = 11
> day_to_int XII = 12
> day_to_int XIII = 13
> day_to_int XIV = 14
> day_to_int XV = 15
> day_to_int XVI = 16
> day_to_int XVII = 17
> day_to_int XVIII = 18
> day_to_int XIX = 19
> day_to_int XX = 20
> day_to_int XXI = 21
> day_to_int XXII = 22
> day_to_int XXIII = 23
> day_to_int XXIV = 24
> day_to_int XXV = 25
> day_to_int XXVI = 26
> day_to_int XXVII = 27
> day_to_int XXVIII = 28
> day_to_int XXIX = 29
> day_to_int XXX = 30
> day_to_int XXXI = 31

> month_to_int :: Monat -> Int
> month_to_int Jan = 1
> month_to_int Feb = 2
> month_to_int Mar = 3
> month_to_int Apr = 4
> month_to_int Mai = 5
> month_to_int Jun = 6
> month_to_int Jul = 7
> month_to_int Aug = 8
> month_to_int Sep = 9
> month_to_int Okt = 10
> month_to_int Nov = 11
> month_to_int Dez = 12

> int_to_day :: Int -> Tag
> int_to_day 1 = I
> int_to_day 2 = II
> int_to_day 3 = III
> int_to_day 4 = IV
> int_to_day 5 = V
> int_to_day 6 = VI
> int_to_day 7 = VII
> int_to_day 8 = VIII
> int_to_day 9 = IX
> int_to_day 10 = X
> int_to_day 11 = XI
> int_to_day 12 = XII
> int_to_day 13 = XIII
> int_to_day 14 = XIV
> int_to_day 15 = XV
> int_to_day 16 = XVI
> int_to_day 17 = XVII
> int_to_day 18 = XVIII
> int_to_day 19 = XIX
> int_to_day 20 = XX
> int_to_day 21 = XXI
> int_to_day 22 = XXII
> int_to_day 23 = XXIII
> int_to_day 24 = XXIV
> int_to_day 25 = XXV
> int_to_day 26 = XXVI
> int_to_day 27 = XXVII
> int_to_day 28 = XXVIII
> int_to_day 29 = XXIX
> int_to_day 30 = XXX
> int_to_day 31 = XXXI

> int_to_month :: Int -> Monat
> int_to_month 1 = Jan
> int_to_month 2 = Feb
> int_to_month 3 = Mar
> int_to_month 4 = Apr
> int_to_month 5 = Mai
> int_to_month 6 = Jun
> int_to_month 7 = Jul
> int_to_month 8 = Aug
> int_to_month 9 = Sep
> int_to_month 10 = Okt
> int_to_month 11 = Nov
> int_to_month 12 = Dez

> skonto_to_num :: Skonto -> Int
> skonto_to_num s
>   | s == KeinSkonto = 0
>   | s == DreiProzent = 3
>   | s == FuenfProzent = 5
>   | otherwise = 10

> full_months::[Monat]
> full_months = [Jan, Mar, Mai, Jul, Aug, Okt, Dez]

> is_date_valid :: Datum -> Bool
> is_date_valid d
>   | monat d == Feb =
>      let y = jahr d in
>      let t = tag d in
>         if y `mod` 4 /= 0 && (day_to_int t) > 28 then False
>         else
>            if y `mod` 100 == 0 && y `mod` 400 /= 0 then False
>            else
>               if (day_to_int t) > 29 then False
>               else True
>   | (day_to_int (tag d)) > 30 && not(monat d `elem` full_months) = False
>   | otherwise = True

> is_payment :: Geschaeftsvorfall -> Bool
> is_payment g =
>   case g of
>      Zahlung _ _ _ -> True
>      _ -> False

> is_credit :: Geschaeftsvorfall -> Bool
> is_credit g =
>   case g of
>      Gutschrift _ _ -> True
>      _ -> False

> is_p_credit :: AP_Geschaeftsvorfall -> Bool
> is_p_credit g =
>   case g of
>      P_Gutschrift _ _ -> True
>      _ -> False

> is_k_credit :: K_Geschaeftsvorfall -> Bool
> is_k_credit g =
>   case g of
>      K_Gutschrift _ _ -> True
>      _ -> False

> kkb_to_tuples :: KonsolidiertesKassabuch -> [(P_Geschaeftspartner, K_Geschaeftsvorfall)]
> kkb_to_tuples (KKB x) = x

===================================================================================
Aufgabe A.1

> type P_Geschaeftspartner = Geschaeftspartner
> data AP_Geschaeftsvorfall
>    = AP_Zahlung { netto :: Netto,
>                   zahlungsdatum :: Datum
>                 }
>     | P_Gutschrift { gutschrift :: Cent,
>                      gutschriftsdatum :: Datum
>                    } deriving (Eq,Show)
> type AP_Kassabucheintrag = (P_Geschaeftspartner,AP_Geschaeftsvorfall)


> waup :: Kassabucheintrag -> AP_Kassabucheintrag
> waup (g, v) = eval_payment_sum $ eval_payment_date (g, v)


Evaluate payment date: determine the type of the payment and calculate the correct date with the correct attribute

> eval_payment_date :: Kassabucheintrag -> Kassabucheintrag
> eval_payment_date (g, v)
>   | (is_payment v) && (is_date_valid (zahlung_vom v)) =
>       if is_date_valid (seit g) then (g, v)
>       else (g', v)
>   | (is_credit v) && (is_date_valid (gutschrift_vom v)) =
>       if is_date_valid (seit g) then (g, v)
>       else (g', v)
>   | otherwise =
>       if (is_payment v) then (g', z)
>       else (g', gs)
>   where
>       g' = GP (partner g) (correct_date (seit g))
>       z = Zahlung (brutto v) (skonto v) (correct_date (zahlung_vom v))
>       gs = Gutschrift (gutschriftsbetrag v) (correct_date (gutschrift_vom v))

Simple datatype conversion

> eval_payment_sum :: Kassabucheintrag -> AP_Kassabucheintrag
> eval_payment_sum (g, v) = (g, correct_sum v)

Calculate the correct date

> correct_date :: Datum -> Datum
> correct_date d
>   | monat d == Feb =
>         if y `mod` 4 /= 0 && (day_to_int t) > 28 then fm
>         else
>            if y `mod` 100 == 0 && y `mod` 400 /= 0 then fm
>            else
>               if (day_to_int t) > 29 then fm
>               else d
>   | (day_to_int t) > 30 && not(monat d `elem` full_months) = nm
>   | otherwise = d
>   where
>       y = jahr d
>       t = tag d
>       fm = D (int_to_day 1) Mar y
>       nm = D (int_to_day 1) (int_to_month ((month_to_int (monat d)) + 1)) y

Calculate the sum by reducing the "tax" from the brutto sum

> correct_sum :: Geschaeftsvorfall -> AP_Geschaeftsvorfall
> correct_sum g
>   | is_credit g = P_Gutschrift (gutschriftsbetrag g) (gutschrift_vom g)
>   | otherwise = AP_Zahlung n (zahlung_vom g)
>   where
>       b = cents (brutto g)
>       s = skonto_to_num (skonto g)
>       n = C ((b - ((b * s) `div` 100)) :: Nat1)


===================================================================================
Aufgabe A.2

Nur Werte zwischen 0 und 99 fuer cent!

> data EuroCent = EC { euro :: Nat1,
>                      cent :: Nat1
>                    } deriving (Eq,Ord,Show)

> data K_Geschaeftsvorfall = K_Zahlung { ec_netto :: EuroCent,
>                                        zahlungsdatum' :: Datum
>                                      }
>                            | K_Gutschrift { ec_gutschrift :: EuroCent,
>                                             gutschriftsdatum' :: Datum
>                                           } deriving (Eq,Show)

> newtype KonsolidiertesKassabuch
>     = KKB [(P_Geschaeftspartner,K_Geschaeftsvorfall)]
>       deriving (Eq,Show)

Declare operators for easier calculations

> instance Num EuroCent where
>   (+) s s' = (add_ec s s')
>   (-) s s' = (diff_ec s s')
>   fromInteger i = EC (fromIntegral(i `div` 100) :: Nat1) (fromIntegral(i `mod` 100) :: Nat1)

> add_ec :: EuroCent -> EuroCent -> EuroCent
> add_ec s s'
>   | total_cents > 100 = EC (total_euro + 1) (total_cents - 100)
>   | otherwise = EC total_euro total_cents
>   where
>       total_cents = (cent s) + (cent s')
>       total_euro = (euro s) + (euro s')

> diff_ec :: EuroCent -> EuroCent -> EuroCent
> diff_ec s s'
>   | total_cents < 0 = EC (total_euro - 1) (100 + total_cents)
>   | otherwise = EC total_euro total_cents
>   where
>       total_cents = (cent s) - (cent s')
>       total_euro = (euro s) - (euro s')

> konsolidiere :: Kassabuch -> KonsolidiertesKassabuch
> konsolidiere k = consolidate_cash_book k []

Consolidate each payment and add it to the registry book

> consolidate_cash_book :: Kassabuch -> [(P_Geschaeftspartner,K_Geschaeftsvorfall)] -> KonsolidiertesKassabuch
> consolidate_cash_book (KB (x:xs)) res
>   | length x /= 0 && null xs = KKB(res ++ [entry])
>   | otherwise = consolidate_cash_book (KB(xs)) (res ++ [entry])
>   where
>       (g, v) = x
>       entry = consolidate_payment $ eval_payment_sum $ eval_payment_date (g, v)

> consolidate_payment :: AP_Kassabucheintrag -> (P_Geschaeftspartner,K_Geschaeftsvorfall)
> consolidate_payment (g, v) = (g, consolidate_payment_sum v)

Split the total sum in euros and cents using the rest and result of division by 100

> consolidate_payment_sum :: AP_Geschaeftsvorfall -> K_Geschaeftsvorfall
> consolidate_payment_sum g
>   | is_p_credit g =
>       let
>           sum = toInteger(cents (gutschrift g))
>           bills = fromIntegral(sum `div` 100) :: Nat1
>           coins = fromIntegral(sum `mod` 100) :: Nat1
>           res = EC bills coins
>       in
>       K_Gutschrift res (gutschriftsdatum g)
>   | otherwise =
>       let
>           sum = toInteger(cents (netto g))
>           bills = fromIntegral(sum `div` 100) :: Nat1
>           coins = fromIntegral(sum `mod` 100) :: Nat1
>           res = EC bills coins
>       in
>       K_Zahlung res (zahlungsdatum g)


===================================================================================
Aufgabe A.3

> data Saldo = Forderungssaldo { fs :: EuroCent }
>              | Zahlungssaldo { zs :: EuroCent }
>              | Ausgeglichen
>              | Keine_Geschaeftsbeziehung deriving (Eq,Show)

> saldo :: P_Geschaeftspartner -> KonsolidiertesKassabuch -> Saldo
> saldo p k = get_balance $ get_partner_cashflow p k []

Get total balance of the specified cashbook

> get_balance :: KonsolidiertesKassabuch -> Saldo
> get_balance k
>   | payments == 0 && credit == 0 = Keine_Geschaeftsbeziehung
>   | payments == credit = Ausgeglichen
>   | payments > credit = Zahlungssaldo (payments - credit)
>   | otherwise = Forderungssaldo (credit - payments)
>   where
>       init = EC 0 0
>       payments = calculate_partner_payments k init
>       credit = calculate_partner_credit k init

Extract partner cashflow from cashbook

> get_partner_cashflow :: P_Geschaeftspartner -> KonsolidiertesKassabuch -> [(P_Geschaeftspartner,K_Geschaeftsvorfall)] -> KonsolidiertesKassabuch
> get_partner_cashflow p (KKB(x:xs)) res
>   | length x /= 0 && null xs =
>       if g == p then KKB(res ++ [(p, v)])
>       else KKB(res)
>   | g == p = get_partner_cashflow p (KKB(xs)) (res ++ [(p, v)])
>   | otherwise = get_partner_cashflow p (KKB(xs)) res
>   where
>       (g, v) = x

Calculate the payments of all partners

> calculate_partner_payments :: KonsolidiertesKassabuch -> EuroCent -> EuroCent
> calculate_partner_payments (KKB []) _ = (EC 0 0)
> calculate_partner_payments (KKB(x:xs)) res
>   | length x /= 0 && null xs =
>       if is_k_credit v then res
>       else res + (ec_netto v)
>   | is_k_credit v = calculate_partner_payments (KKB(xs)) res
>   | otherwise = calculate_partner_payments (KKB(xs)) (res + (ec_netto v))
>   where
>       (g,v) = x

Calculate the cerdits of all partners

> calculate_partner_credit :: KonsolidiertesKassabuch -> EuroCent -> EuroCent
> calculate_partner_credit (KKB []) _ = (EC 0 0)
> calculate_partner_credit (KKB(x:xs)) res
>   | null (x:xs) = res
>   | length x /= 0 && null xs =
>       if is_k_credit v then res + (ec_gutschrift v)
>       else res
>   | is_k_credit v = calculate_partner_credit (KKB(xs)) (res + (ec_gutschrift v))
>   | otherwise = calculate_partner_credit (KKB(xs)) res
>   where
>       (g,v) = x


===================================================================================
Aufgabe A.4

> newtype SaldiertesKassabuch = SKB [(Geschaeftspartner,Saldo)] deriving (Eq,Show)

> saldiere :: Kassabuch -> SaldiertesKassabuch
> saldiere k = SKB(nub(sortOn fst [(g, saldo g (konsolidiere k)) | (g,v) <- kkb_to_tuples (konsolidiere k)]))
